com.smartgwt.client.widgets.form.fields

## Class SpinnerItem

- java.lang.Object
- - com.smartgwt.client.core.JsObject
  - - com.smartgwt.client.core.DataClass
    - - com.smartgwt.client.core.RefDataClass
      - - com.smartgwt.client.data.Field
        - - com.smartgwt.client.widgets.form.fields.FormItem
          - - com.smartgwt.client.widgets.form.fields.TextItem
            - - com.smartgwt.client.widgets.form.fields.SpinnerItem

- All Implemented Interfaces:
    com.google.gwt.event.shared.HasHandlers, HasBlurHandlers, HasChangedHandlers, HasChangeHandlers, HasClickHandlers, HasDoubleClickHandlers, HasEditorEnterHandlers, HasEditorExitHandlers, HasFocusHandlers, HasIconClickHandlers, HasIconKeyPressHandlers, HasItemHoverHandlers, HasKeyDownHandlers, HasKeyPressHandlers, HasKeyUpHandlers, HasPendingStatusChangedHandlers, HasPickerIconClickHandlers, HasShowContextMenuHandlers, HasTitleClickHandlers, HasTitleDoubleClickHandlers, HasTitleHoverHandlers, HasValueHoverHandlers, HasValueIconClickHandlers

      public class SpinnerItem
      extends TextItem

  Item for picking a number. Includes arrow buttons to increase / decrease the value

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class com.smartgwt.client.widgets.form.fields.FormItem

      `FormItem.CustomStateGetter, FormItem.StateCustomizer`

  - ### Field Summary

    - ### Fields inherited from class com.smartgwt.client.widgets.form.fields.FormItem

      `configOnly, scClassName, warnOnEditorTypeConversion, warnOnEditorTypeConversionDefault`

    - ### Fields inherited from class com.smartgwt.client.core.RefDataClass

      `id`

    - ### Fields inherited from class com.smartgwt.client.core.DataClass

      `factoryCreated, factoryProperties`

    - ### Fields inherited from class com.smartgwt.client.core.JsObject

      `jsObj`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `SpinnerItem()`
    `SpinnerItem(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `SpinnerItem(java.lang.String name)`
    `SpinnerItem(java.lang.String name, java.lang.String title)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static void` | `changeAutoChildDefaults(java.lang.String autoChildName, Canvas defaults)` Changes the defaults for Canvas AutoChildren named `autoChildName`.
    `static void` | `changeAutoChildDefaults(java.lang.String autoChildName, FormItem defaults)` Changes the defaults for FormItem AutoChildren named `autoChildName`.
    `static void` | `changePickerIconDefaults(FormItemIcon defaults)`
    `FormItemIcon` | `getDecreaseIcon()` In `stacked mode`, the icon to decrease the spinner's value (a down arrow by default).
    `FormItemIcon` | `getIncreaseIcon()` In `stacked mode`, the icon to increase the spinner's value (an up arrow by default).
    `java.lang.String` | `getMask()` Not applicable to a SpinnerItem.
    `java.lang.Boolean` | `getMaskOverwriteMode()` Not applicable to a SpinnerItem.
    `java.lang.String` | `getMaskPadChar()` Not applicable to a SpinnerItem.
    `java.lang.String` | `getMaskPromptChar()` Not applicable to a SpinnerItem.
    `java.lang.Boolean` | `getMaskSaveLiterals()` Not applicable to a SpinnerItem.
    `java.lang.Double` | `getMax()` Maximum valid value for this item.
    `java.lang.Double` | `getMin()` Minimum valid value for this item.
    `static SpinnerItem` | `getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `java.lang.Integer` | `getStackedIconsHeight()` In `stacked icons mode` this property can be used to specify the height of both the increase and decrease icon.
    `java.lang.Integer` | `getStackedIconsWidth()` In `stacked icons mode` this property can be used to specify the width of both the increase and decrease icon.
    `double` | `getStep()` How much should the value be incremented / decremented when the user hits the icons to increase / decrease the value?
    `FormItemIcon` | `getUnstackedDecreaseIcon()` In `unstacked mode`, the icon to decrease the `SpinnerItem`'s value.
    `FormItemIcon` | `getUnstackedIncreaseIcon()` In `unstacked mode`, the icon to increase the `SpinnerItem`'s value.
    `java.lang.String` | `getUnstackedPrintTextBoxStyle()` In `unstacked mode`, the base CSS class name for the `SpinnerItem`'s text box element when printed.
    `java.lang.String` | `getUnstackedReadOnlyTextBoxStyle()`
    `java.lang.String` | `getUnstackedTextBoxStyle()` In `unstacked mode`, the base CSS class name for the `SpinnerItem`'s text box element.
    `java.lang.Boolean` | `getWriteStackedIcons()` When set to `true`, the increase and decrease icons are stacked on top of each other, also called stacked mode.
    `SpinnerItem` | `setDecreaseIconProperties(FormItemIcon decreaseIconProperties)` FormItemIcon properties applied to the `decreaseIcon` AutoChild of this SpinnerItem.
    `static void` | `setDefaultProperties(SpinnerItem spinnerItemProperties)` Class level method to set the default properties of this class.
    `SpinnerItem` | `setIncreaseIconProperties(FormItemIcon increaseIconProperties)` FormItemIcon properties applied to the `increaseIcon` AutoChild of this SpinnerItem.
    `SpinnerItem` | `setMask(java.lang.String mask)` Not applicable to a SpinnerItem.
    `SpinnerItem` | `setMaskOverwriteMode(java.lang.Boolean maskOverwriteMode)` Not applicable to a SpinnerItem.
    `SpinnerItem` | `setMaskPadChar(java.lang.String maskPadChar)` Not applicable to a SpinnerItem.
    `SpinnerItem` | `setMaskPromptChar(java.lang.String maskPromptChar)` Not applicable to a SpinnerItem.
    `SpinnerItem` | `setMaskSaveLiterals(java.lang.Boolean maskSaveLiterals)` Not applicable to a SpinnerItem.
    `SpinnerItem` | `setMax(double max)`
    `SpinnerItem` | `setMax(java.lang.Double max)` Maximum valid value for this item.
    `SpinnerItem` | `setMax(java.lang.Integer max)`
    `SpinnerItem` | `setMin(double min)`
    `SpinnerItem` | `setMin(java.lang.Double min)` Minimum valid value for this item.
    `SpinnerItem` | `setMin(java.lang.Integer min)`
    `void` | `setNextValueHandler(NextValueHandler handler)` When `min` and `max` are both null or unspecified, the nextValueHandler is used to get the next higher value from the currentValue.
    `void` | `setPreviousValueHandler(PreviousValueHandler handler)` When `min` and `max` are both null or unspecified, the previousValueHandler is used to get the previous lower value from the currentValue.
    `SpinnerItem` | `setStackedIconsHeight(java.lang.Integer stackedIconsHeight)` In `stacked icons mode` this property can be used to specify the height of both the increase and decrease icon.
    `SpinnerItem` | `setStackedIconsWidth(java.lang.Integer stackedIconsWidth)` In `stacked icons mode` this property can be used to specify the width of both the increase and decrease icon.
    `SpinnerItem` | `setStep(double step)` How much should the value be incremented / decremented when the user hits the icons to increase / decrease the value?
    `SpinnerItem` | `setStep(java.lang.Double step)`
    `SpinnerItem` | `setStep(java.lang.Integer step)`
    `SpinnerItem` | `setUnstackedPrintTextBoxStyle(java.lang.String unstackedPrintTextBoxStyle)` In `unstacked mode`, the base CSS class name for the `SpinnerItem`'s text box element when printed.
    `SpinnerItem` | `setUnstackedReadOnlyTextBoxStyle(java.lang.String unstackedReadOnlyTextBoxStyle)`
    `SpinnerItem` | `setUnstackedTextBoxStyle(java.lang.String unstackedTextBoxStyle)` In `unstacked mode`, the base CSS class name for the `SpinnerItem`'s text box element.
    `SpinnerItem` | `setWriteStackedIcons(java.lang.Boolean writeStackedIcons)` When set to `true`, the increase and decrease icons are stacked on top of each other, also called stacked mode.

    - ### Methods inherited from class com.smartgwt.client.widgets.form.fields.TextItem

      `deselectValue, deselectValue, getBrowserAutoCapitalize, getBrowserAutoCorrect, getBrowserInputType, getChangeOnKeypress, getCharacterCasing, getEditProxyConstructor, getEnforceLength, getEnteredValue, getEscapeHTML, getFetchMissingValues, getFormatOnBlur, getFormatOnFocusChange, getHint, getKeyPressFilter, getLength, getPrintFullText, getSaveOnEnter, getSelectionRange, getSelectOnClick, getSelectOnFocus, getShowHintInField, getShowInputElement, getSupportsCutPasteEvents, getSuppressBrowserClearIcon, getTextBoxStyle, getUsePlaceholderForHint, getValueAsString, pendingStatusChanged, selectValue, setBrowserAutoCapitalize, setBrowserAutoCorrect, setBrowserInputType, setChangeOnKeypress, setCharacterCasing, setDefaultProperties, setEditProxyConstructor, setEnforceLength, setEscapeHTML, setFetchMissingValues, setFormatOnBlur, setFormatOnFocusChange, setKeyPressFilter, setLength, setPastedValueTransformer, setPrintFullText, setSaveOnEnter, setSelectionRange, setSelectOnClick, setSelectOnFocus, setShowHintInField, setShowInputElement, setSupportsCutPasteEvents, setSuppressBrowserClearIcon, setTextBoxStyle, setUsePlaceholderForHint, shouldFetchMissingValue`

    - ### Methods inherited from class com.smartgwt.client.widgets.form.fields.FormItem

      `_getValue, addBlurHandler, addChangedHandler, addChangeHandler, addClickHandler, addDoubleClickHandler, addEditorEnterHandler, addEditorExitHandler, addFocusHandler, addIcon, addIcon, addIconClickHandler, addIconKeyPressHandler, addItemHoverHandler, addKeyDownHandler, addKeyPressHandler, addKeyUpHandler, addPendingStatusChangedHandler, addPickerIconClickHandler, addShowContextMenuHandler, addTitleClickHandler, addTitleDoubleClickHandler, addTitleHoverHandler, addValueHoverHandler, addValueIconClickHandler, applyFormula, asSGWTComponent, blurItem, canEditCriterion, checkFormItemType, clearErrors, clearValue, disable, disableIcon, enable, enableIcon, error, error, errorIfNotCreated, focusAfterItem, focusInItem, getAccessKey, getAlign, getAllowExpressions, getAlwaysFetchMissingValues, getAlwaysShowControlBox, getApplyAlignToText, getApplyHeightToTextBox, getAriaRole, getAttribute, getAttributeAsBoolean, getAttributeAsBoolean, getAttributeAsDate, getAttributeAsDouble, getAttributeAsFloat, getAttributeAsInt, getAttributeAsJavaScriptObject, getAttributeAsObject, getAttributeAsString, getAutoComplete, getAutoCompleteKeywords, getBrowserSpellCheck, getCanEdit, getCanEditOpaqueValues, getCanFocus, getCanHover, getCanSelectText, getCanTabToIcons, getCanvasAutoChild, getCellHeight, getCellStyle, getClassName, getClipStaticValue, getClipTitle, getConfig, getContainerWidget, getControlStyle, getCriteriaField, getCriterion, getCriterion, getCursorPosition, getCustomState, getDataPath, getDateFormatter, getDecimalPad, getDecimalPrecision, getDefaultIconSrc, getDefaultOperator, getDefaultValue, getDestroyed, getDisabled, getDisabledHover, getDisableIconsOnReadOnly, getDisplayField, getDisplayFieldName, getDisplayValue, getDisplayValue, getEditorTypeConfig, getEditPendingCSSText, getEmptyDisplayValue, getEmptyValueIcon, getEndRow, getErrorIconHeight, getErrorIconProperties, getErrorIconSrc, getErrorIconWidth, getErrorMessageWidth, getErrors, getExportFormat, getExtraControlTableCSS, getExtraTextBoxCSS, getFieldName, getFilterLocally, getForeignDisplayField, getForm, getFormat, getFormItemAutoChild, getFormula, getFullDataPath, getGlobalTabIndex, getGridColNum, getGridRowNum, getHeight, getHeightAsString, getHidden, getHintStyle, getHoverAlign, getHoverDelay, getHoverFocusKey, getHoverHeight, getHoverHeightAsString, getHoverOpacity, getHoverPersist, getHoverStyle, getHoverVAlign, getHoverWidth, getHoverWidthAsString, getIcon, getIconBaseStyle, getIconHeight, getIconHSpace, getIconPageRect, getIconPrompt, getIconRect, getIcons, getIconTabPosition, getIconVAlign, getIconWidth, getID, getImageURLPrefix, getImageURLSuffix, getImplicitSave, getImplicitSaveOnBlur, getInputFormat, getLeft, getLinearColSpan, getLinearColSpanAsString, getLinearEndRow, getLinearEndRowAsString, getLinearStartRow, getLinearStartRowAsString, getLinearWidth, getLinearWidthAsString, getListGrid, getLoadingDisplayValue, getLocateItemBy, getMinHintWidth, getMultiple, getMultipleValueSeparator, getName, getNullOriginalValueText, getOperator, getOptionCriteria, getOptionDataSource, getOptionDataSourceAsString, getOptionFilterContext, getOptionOperationId, getOptionTextMatchStyle, getOriginalValueMessage, getPageLeft, getPageRect, getPageTop, getPaletteDefaults, getPicker, getPickerIcon, getPickerIcon, getPickerIconHeight, getPickerIconName, getPickerIconPrompt, getPickerIconProperties, getPickerIconSrc, getPickerIconStyle, getPickerIconTabPosition, getPickerIconWidth, getPixelHeight, getPixelWidth, getPrintReadOnlyTextBoxStyle, getPrintTextBoxStyle, getPrintTitleStyle, getPrompt, getReadOnlyCanSelectText, getReadOnlyControlStyle, getReadOnlyDisplay, getReadOnlyHover, getReadOnlyTextBoxStyle, getReadOnlyWhen, getRect, getRedrawOnChange, getRejectInvalidValueOnChange, getRequired, getRequiredMessage, getRequiredWhen, getRowSpan, getScClassName, getSelectedRecord, getShouldSaveValue, getShowClippedTitleOnHover, getShowClippedValueOnHover, getShowDeletions, getShowDisabled, getShowDisabledIconsOnFocus, getShowDisabledPickerIconOnFocus, getShowErrorIcon, getShowErrorIconInline, getShowErrorStyle, getShowErrorText, getShowFocused, getShowFocusedErrorState, getShowFocusedIcons, getShowFocusedPickerIcon, getShowHint, getShowIcons, getShowIconsOnFocus, getShowImageAsURL, getShowOldValueInHover, getShowOver, getShowOverIcons, getShowPending, getShowPickerIcon, getShowPickerIconOnFocus, getShowRTL, getShowTitle, getShowValueIconOnly, getStartRow, getStaticHeight, getStopOnError, getStoreDisplayValues, getSuppressValueIcon, getSynchronousValidation, getTabIndex, getTextAlign, getTextFormula, getTimeFormatter, getTitle, getTitleAlign, getTitleColSpan, getTitleOrientation, getTitleStyle, getTitleVAlign, getTooltip, getTop, getType, getUpdateControlOnOver, getUpdatePickerIconOnOver, getUpdateTextBoxOnOver, getUseAdvancedCriteria, getUseDisabledHintStyleForReadOnly, getUseLocalDisplayFieldValue, getValidateOnChange, getValidateOnExit, getValidOperators, getVAlign, getValue, getValueAsFloat, getValueAsInteger, getValueAsLong, getValueAsRecordList, getValueDeselectedCSSText, getValueField, getValueFieldName, getValueIconHeight, getValueIconLeftPadding, getValueIconRightPadding, getValueIconSize, getValueIconWidth, getValueMap, getValueMapAsArray, getVisible, getVisibleHeight, getVisibleTitleWidth, getVisibleWhen, getVisibleWidth, getWarnOnEditorTypeConversion, getWarnOnEditorTypeConversionDefault, getWidth, getWidthAsString, getWrapHintText, getWrapStaticValue, getWrapTitle, handleWarnOnEditorTypeConversion, hasAdvancedCriteria, hasErrors, hide, hideIcon, invalidateDisplayValueCache, isAssignableFrom, isConfigOnly, isCreated, isCutEvent, isDisabled, isDrawn, isFocused, isInGrid, isPasteEvent, isVisible, linkToInstanceUponCreate, mapDisplayToValue, mapValueToDisplay, mapValueToDisplay, mapValueToDisplay, redraw, redraw, removeIcon, selectedRecordChanged, setAccessKey, setAlign, setAllowExpressions, setAlwaysFetchMissingValues, setAlwaysShowControlBox, setApplyAlignToText, setApplyHeightToTextBox, setAriaRole, setAriaState, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAutoChildConstructor, setAutoChildProperties, setAutoChildProperties, setAutoChildProperties, setAutoChildVisibility, setAutoComplete, setAutoCompleteKeywords, setBrowserSpellCheck, setCanEdit, setCanEditCriterionPredicate, setCanEditOpaqueValues, setCanFocus, setCanHover, setCanSelectText, setCanTabToIcons, setCellHeight, setCellStyle, setClipStaticValue, setClipTitle, setColSpan, setColSpan, setConfigOnly, setControlStyle, setCriteriaField, setCriterion, setCriterionGetter, setCriterionSetter, setCustomStateGetter, setDataPath, setDateFormatter, setDecimalPad, setDecimalPrecision, setDefaultIconSrc, setDefaultOperator, setDefaultProperties, setDefaultValue, setDefaultValue, setDefaultValue, setDefaultValue, setDefaultValue, setDefaultValue, setDefaultValue, setDisabled, setDisabledHover, setDisableIconsOnReadOnly, setDisplayField, setDisplayFormat, setDisplayFormat, setEditorProperties, setEditorType, setEditorType, setEditorType, setEditorValueFormatter, setEditorValueParser, setEditPendingCSSText, setEmptyDisplayValue, setEmptyValueIcon, setEndRow, setErrorFormatter, setErrorIconHeight, setErrorIconProperties, setErrorIconSrc, setErrorIconWidth, setErrorMessageWidth, setErrorOrientation, setErrors, setErrors, setExportFormat, setExtraControlTableCSS, setExtraTextBoxCSS, setFilterLocally, setForeignDisplayField, setFormat, setFormula, setGlobalTabIndex, setHeight, setHeight, setHidden, setHint, setHintStyle, setHoverAlign, setHoverDelay, setHoverFocusKey, setHoverHeight, setHoverHeight, setHoverOpacity, setHoverPersist, setHoverStyle, setHoverVAlign, setHoverWidth, setHoverWidth, setIconBaseStyle, setIconDisabled, setIconHeight, setIconHSpace, setIconPrompt, setIcons, setIconShowOnFocus, setIconVAlign, setIconWidth, setID, setImageURLPrefix, setImageURLSuffix, setImplicitSave, setImplicitSaveOnBlur, setInitHandler, setInputFormat, setInputTransformer, setItemHoverFormatter, setItemTitleHoverFormatter, setItemValueHoverFormatter, setJavaScriptObject, setLeft, setLinearColSpan, setLinearColSpan, setLinearEndRow, setLinearEndRow, setLinearStartRow, setLinearStartRow, setLinearWidth, setLinearWidth, setLoadingDisplayValue, setLocateItemBy, setMinHintWidth, setMultiple, setMultipleValueSeparator, setName, setNullOriginalValueText, setNullProperty, setOperator, setOptionCriteria, setOptionDataSource, setOptionDataSource, setOptionFilterContext, setOptionOperationId, setOptionTextMatchStyle, setOriginalValueMessage, setPickerIconHeight, setPickerIconName, setPickerIconPrompt, setPickerIconProperties, setPickerIconSrc, setPickerIconStyle, setPickerIconWidth, setPrintReadOnlyTextBoxStyle, setPrintTextBoxStyle, setPrintTitleStyle, setPrompt, setProperty, setProperty, setProperty, setProperty, setProperty, setReadOnlyCanSelectText, setReadOnlyControlStyle, setReadOnlyDisplay, setReadOnlyHover, setReadOnlyTextBoxStyle, setReadOnlyWhen, setRedrawOnChange, setRejectInvalidValueOnChange, setRequired, setRequiredMessage, setRequiredWhen, setRowSpan, setScClassName, setShouldSaveValue, setShowClippedTitleOnHover, setShowClippedValueOnHover, setShowDeletions, setShowDisabled, setShowDisabledIconsOnFocus, setShowDisabledPickerIconOnFocus, setShowErrorIcon, setShowErrorIconInline, setShowErrorStyle, setShowErrorText, setShowFocused, setShowFocusedErrorState, setShowFocusedIcons, setShowFocusedPickerIcon, setShowHint, setShowIcons, setShowIconsOnFocus, setShowIfCondition, setShowImageAsURL, setShowOldValueInHover, setShowOver, setShowOverIcons, setShowPending, setShowPickerIcon, setShowPickerIconOnFocus, setShowRTL, setShowTitle, setShowValueIconOnly, setStartRow, setStateCustomizer, setStaticHeight, setStopOnError, setStoreDisplayValues, setSuppressValueIcon, setSynchronousValidation, setTabIndex, setTextAlign, setTextFormula, setTimeFormatter, setTitle, setTitleAlign, setTitleColSpan, setTitleHoverFormatter, setTitleOrientation, setTitleStyle, setTitleVAlign, setTooltip, setTop, setType, setUpdateControlOnOver, setUpdatePickerIconOnOver, setUpdateTextBoxOnOver, setUseAdvancedCriteria, setUseDisabledHintStyleForReadOnly, setUseLocalDisplayFieldValue, setUseObjectFactoryForTypeFallback, setValidateOnChange, setValidateOnExit, setValidators, setValidOperators, setVAlign, setValue, setValue, setValue, setValue, setValue, setValue, setValueDeselectedCSSText, setValueField, setValueFormatter, setValueHoverFormatter, setValueIconHeight, setValueIconLeftPadding, setValueIconMapper, setValueIconRightPadding, setValueIcons, setValueIconSize, setValueIconWidth, setValueMap, setValueMap, setVisible, setVisibleWhen, setWarnOnEditorTypeConversion, setWarnOnEditorTypeConversionDefault, setWidth, setWidth, setWrapHintText, setWrapStaticValue, setWrapTitle, shouldApplyHeightToTextBox, shouldSaveOnEnter, shouldStopKeyPressBubbling, show, showIcon, showPicker, stopHover, storeValue, storeValue, updateState, validate, valueClipped`

    - ### Methods inherited from class com.smartgwt.client.data.Field

      `getCanExport, getExportTitle, getSortByField, setCanExport, setExportTitle, setSortByField`

    - ### Methods inherited from class com.smartgwt.client.core.RefDataClass

      `getRef, getRef, internalSetID`

    - ### Methods inherited from class com.smartgwt.client.core.DataClass

      `applyFactoryProperties, doAddHandler, fireEvent, getAttributeAsDoubleArray, getAttributeAsElement, getAttributeAsIntArray, getAttributeAsLong, getAttributeAsMap, getAttributeAsObject, getAttributeAsRecord, getAttributeAsStringArray, getAttributes, getHandlerCount, isFactoryCreated, setAttribute, setAttribute, setAttribute, setAttributeAsJavaObject, setFactoryCreated`

    - ### Methods inherited from class com.smartgwt.client.core.JsObject

      `equals, getJsObj, hashCode, setJsObj`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface com.google.gwt.event.shared.HasHandlers

      `fireEvent`

- - ### Constructor Detail

    - #### SpinnerItem

          public SpinnerItem()

    - #### SpinnerItem

          public SpinnerItem(com.google.gwt.core.client.JavaScriptObject jsObj)

    - #### SpinnerItem

          public SpinnerItem(java.lang.String name)

    - #### SpinnerItem

          public SpinnerItem(java.lang.String name,
                             java.lang.String title)

  - ### Method Detail

    - #### getOrCreateRef

          public static SpinnerItem getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)

    - #### changeAutoChildDefaults

          public static void changeAutoChildDefaults(java.lang.String autoChildName,
                                                     Canvas defaults)

      Changes the defaults for Canvas AutoChildren named `autoChildName`.
      Parameters:
        `autoChildName` - name of an AutoChild to customize the defaults for.
        `defaults` - Canvas defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties. For usage tips on this param, see `SGWTProperties`.
      See Also:
        `AutoChildUsage`

    - #### changeAutoChildDefaults

          public static void changeAutoChildDefaults(java.lang.String autoChildName,
                                                     FormItem defaults)

      Changes the defaults for FormItem AutoChildren named `autoChildName`.
      Parameters:
        `autoChildName` - name of an AutoChild to customize the defaults for.
        `defaults` - FormItem defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties. For usage tips on this param, see `SGWTProperties`.
      See Also:
        `AutoChildUsage`

    - #### changePickerIconDefaults

          public static void changePickerIconDefaults(FormItemIcon defaults)

    - #### getDecreaseIcon

          public FormItemIcon getDecreaseIcon()

      In `stacked mode`, the icon to decrease the spinner's value (a down arrow by default). This icon is generated automatically using the `com.smartgwt.client.types.AutoChild` pattern. For skinning purposes, `decreaseIconDefaults` may be modified using changeDefaults().

      If sizes for the increase and decrease icons are not explicitly specified in their autoChild configuration, they will be derived from the specified `stackedIconsHeight` and `stackedIconsWidth` properties.

      See the `skinning overview` for details on how to provide a sprited image for these icons.

      This component is an AutoChild named "decreaseIcon". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        Current decreaseIcon value. Default value is null

    - #### setDecreaseIconProperties

          public SpinnerItem setDecreaseIconProperties(FormItemIcon decreaseIconProperties)

      FormItemIcon properties applied to the `decreaseIcon` AutoChild of this SpinnerItem.
      Parameters:
        `decreaseIconProperties` - New decreaseIconProperties value. Default value is null
      Returns:
        `SpinnerItem` instance, for chaining setter calls

    - #### getIncreaseIcon

          public FormItemIcon getIncreaseIcon()

      In `stacked mode`, the icon to increase the spinner's value (an up arrow by default). This icon is generated automatically using the `com.smartgwt.client.types.AutoChild` pattern. For skinning purposes, `increaseIconDefaults` may be modified using changeDefaults().

      If sizes for the increase and decrease icons are not explicitly specified in their autoChild configuration, they will be derived from the specified `stackedIconsHeight` and `stackedIconsWidth` properties.

      See the `skinning overview` for details on how to provide a sprited image for these icons.

      This component is an AutoChild named "increaseIcon". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        Current increaseIcon value. Default value is null

    - #### setIncreaseIconProperties

          public SpinnerItem setIncreaseIconProperties(FormItemIcon increaseIconProperties)

      FormItemIcon properties applied to the `increaseIcon` AutoChild of this SpinnerItem.
      Parameters:
        `increaseIconProperties` - New increaseIconProperties value. Default value is null
      Returns:
        `SpinnerItem` instance, for chaining setter calls

    - #### setMask

          public SpinnerItem setMask(java.lang.String mask)

      Not applicable to a SpinnerItem.

      Note : This is an advanced setting

      Overrides:
        `setMask` in class `TextItem`
      Parameters:
        `mask` - New mask value. Default value is null
      Returns:
        `SpinnerItem` instance, for chaining setter calls
      See Also:
        `TextItem.setKeyPressFilter(java.lang.String)`, Text - Masked Example

    - #### getMask

          public java.lang.String getMask()

      Not applicable to a SpinnerItem.
      Overrides:
        `getMask` in class `TextItem`
      Returns:
        Current mask value. Default value is null
      See Also:
        `TextItem.getKeyPressFilter()`, Text - Masked Example

    - #### setMaskOverwriteMode

          public SpinnerItem setMaskOverwriteMode(java.lang.Boolean maskOverwriteMode)

      Not applicable to a SpinnerItem.

      Note : This is an advanced setting

      Overrides:
        `setMaskOverwriteMode` in class `TextItem`
      Parameters:
        `maskOverwriteMode` - New maskOverwriteMode value. Default value is null
      Returns:
        `SpinnerItem` instance, for chaining setter calls

    - #### getMaskOverwriteMode

          public java.lang.Boolean getMaskOverwriteMode()

      Not applicable to a SpinnerItem.
      Overrides:
        `getMaskOverwriteMode` in class `TextItem`
      Returns:
        Current maskOverwriteMode value. Default value is null

    - #### setMaskPadChar

          public SpinnerItem setMaskPadChar(java.lang.String maskPadChar)

      Not applicable to a SpinnerItem.

      Note : This is an advanced setting

      Overrides:
        `setMaskPadChar` in class `TextItem`
      Parameters:
        `maskPadChar` - New maskPadChar value. Default value is " "
      Returns:
        `SpinnerItem` instance, for chaining setter calls
      See Also:
        `TextItem.setMaskPromptChar(java.lang.String)`

    - #### getMaskPadChar

          public java.lang.String getMaskPadChar()

      Not applicable to a SpinnerItem.
      Overrides:
        `getMaskPadChar` in class `TextItem`
      Returns:
        Current maskPadChar value. Default value is " "
      See Also:
        `TextItem.getMaskPromptChar()`

    - #### setMaskPromptChar

          public SpinnerItem setMaskPromptChar(java.lang.String maskPromptChar)

      Not applicable to a SpinnerItem.

      Note : This is an advanced setting

      Overrides:
        `setMaskPromptChar` in class `TextItem`
      Parameters:
        `maskPromptChar` - New maskPromptChar value. Default value is "_"
      Returns:
        `SpinnerItem` instance, for chaining setter calls
      See Also:
        `TextItem.setMaskPadChar(java.lang.String)`

    - #### getMaskPromptChar

          public java.lang.String getMaskPromptChar()

      Not applicable to a SpinnerItem.
      Overrides:
        `getMaskPromptChar` in class `TextItem`
      Returns:
        Current maskPromptChar value. Default value is "_"
      See Also:
        `TextItem.getMaskPadChar()`

    - #### setMaskSaveLiterals

          public SpinnerItem setMaskSaveLiterals(java.lang.Boolean maskSaveLiterals)

      Not applicable to a SpinnerItem.

      Note : This is an advanced setting

      Overrides:
        `setMaskSaveLiterals` in class `TextItem`
      Parameters:
        `maskSaveLiterals` - New maskSaveLiterals value. Default value is null
      Returns:
        `SpinnerItem` instance, for chaining setter calls

    - #### getMaskSaveLiterals

          public java.lang.Boolean getMaskSaveLiterals()

      Not applicable to a SpinnerItem.
      Overrides:
        `getMaskSaveLiterals` in class `TextItem`
      Returns:
        Current maskSaveLiterals value. Default value is null

    - #### setMax

          public SpinnerItem setMax(java.lang.Double max)

      Maximum valid value for this item. If this and `min` are both null or unspecified, then the `nextValueHandler` and `previousValueHandler` are used to increase or decrease the value and these handlers are also used to determine the maximum value.
      Parameters:
        `max` - New max value. Default value is null
      Returns:
        `SpinnerItem` instance, for chaining setter calls
      See Also:
        Number - Spinner Example

    - #### getMax

          public java.lang.Double getMax()

      Maximum valid value for this item. If this and `min` are both null or unspecified, then the `nextValueHandler` and `previousValueHandler` are used to increase or decrease the value and these handlers are also used to determine the maximum value.
      Returns:
        Current max value. Default value is null
      See Also:
        Number - Spinner Example

    - #### setMin

          public SpinnerItem setMin(java.lang.Double min)

      Minimum valid value for this item. If this and `max` are both null or unspecified, then the `nextValueHandler` and `previousValueHandler` are used to increase or decrease the value and these handlers are also used to determine the minimum value.
      Parameters:
        `min` - New min value. Default value is null
      Returns:
        `SpinnerItem` instance, for chaining setter calls
      See Also:
        Number - Spinner Example

    - #### getMin

          public java.lang.Double getMin()

      Minimum valid value for this item. If this and `max` are both null or unspecified, then the `nextValueHandler` and `previousValueHandler` are used to increase or decrease the value and these handlers are also used to determine the minimum value.
      Returns:
        Current min value. Default value is null
      See Also:
        Number - Spinner Example

    - #### setStackedIconsHeight

          public SpinnerItem setStackedIconsHeight(java.lang.Integer stackedIconsHeight)

      In `stacked icons mode` this property can be used to specify the height of both the increase and decrease icon. Since the icons are stacked vertically, each icon will be sized to half this specified value. If a height property is explicitly set for the icon via `increaseIconProperties`, `decreaseIconProperties`, or related `Defaults` property blocks, that will take precedence over any specified stackedIconsHeight.

      See also `stackedIconsWidth`.

      Parameters:
        `stackedIconsHeight` - New stackedIconsHeight value. Default value is 18
      Returns:
        `SpinnerItem` instance, for chaining setter calls

    - #### getStackedIconsHeight

          public java.lang.Integer getStackedIconsHeight()

      In `stacked icons mode` this property can be used to specify the height of both the increase and decrease icon. Since the icons are stacked vertically, each icon will be sized to half this specified value. If a height property is explicitly set for the icon via `increaseIconProperties`, `decreaseIconProperties`, or related `Defaults` property blocks, that will take precedence over any specified stackedIconsHeight.

      See also `stackedIconsWidth`.

      Returns:
        Current stackedIconsHeight value. Default value is 18

    - #### setStackedIconsWidth

          public SpinnerItem setStackedIconsWidth(java.lang.Integer stackedIconsWidth)

      In `stacked icons mode` this property can be used to specify the width of both the increase and decrease icon. If a width property is explicitly set for the icon via `increaseIconProperties`, `decreaseIconProperties`, or related `Defaults` property blocks, that will take precedence over any specified stackedIconsWidth.

      See also `stackedIconsHeight`.

      Parameters:
        `stackedIconsWidth` - New stackedIconsWidth value. Default value is 16
      Returns:
        `SpinnerItem` instance, for chaining setter calls

    - #### getStackedIconsWidth

          public java.lang.Integer getStackedIconsWidth()

      In `stacked icons mode` this property can be used to specify the width of both the increase and decrease icon. If a width property is explicitly set for the icon via `increaseIconProperties`, `decreaseIconProperties`, or related `Defaults` property blocks, that will take precedence over any specified stackedIconsWidth.

      See also `stackedIconsHeight`.

      Returns:
        Current stackedIconsWidth value. Default value is 16

    - #### setStep

          public SpinnerItem setStep(double step)

      How much should the value be incremented / decremented when the user hits the icons to increase / decrease the value?

      When providing a `nextValueHandler` and/or `previousValueHandler`, the sign of the step value determines whether these handlers are expected to induce monotonically increasing or decreasing functions.

      Parameters:
        `step` - New step value. Default value is 1
      Returns:
        `SpinnerItem` instance, for chaining setter calls
      See Also:
        Number - Spinner Example

    - #### getStep

          public double getStep()

      How much should the value be incremented / decremented when the user hits the icons to increase / decrease the value?

      When providing a `nextValueHandler` and/or `previousValueHandler`, the sign of the step value determines whether these handlers are expected to induce monotonically increasing or decreasing functions.

      Returns:
        Current step value. Default value is 1
      See Also:
        Number - Spinner Example

    - #### getUnstackedDecreaseIcon

          public FormItemIcon getUnstackedDecreaseIcon()

      In `unstacked mode`, the icon to decrease the `SpinnerItem`'s value.

      By default, `"[SKIN]/DynamicForm/Spinner_decrease_icon.png"` is stretched to an 18x18 icon.

      When `spriting` is enabled, this property will not be used to locate an image, instead, the image is drawn via CSS based on the `FormItemIcon.baseStyle` property.

      This component is an AutoChild named "unstackedDecreaseIcon". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        Current unstackedDecreaseIcon value. Default value is null

    - #### getUnstackedIncreaseIcon

          public FormItemIcon getUnstackedIncreaseIcon()

      In `unstacked mode`, the icon to increase the `SpinnerItem`'s value.

      By default, `"[SKIN]/DynamicForm/Spinner_increase_icon.png"` is stretched to an 18x18 icon.

      When `spriting` is enabled, this property will not be used to locate an image, instead, the image is drawn via CSS based on the `FormItemIcon.baseStyle` property.

      This component is an AutoChild named "unstackedIncreaseIcon". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        Current unstackedIncreaseIcon value. Default value is null

    - #### setUnstackedPrintTextBoxStyle

          public SpinnerItem setUnstackedPrintTextBoxStyle(java.lang.String unstackedPrintTextBoxStyle)

      In `unstacked mode`, the base CSS class name for the `SpinnerItem`'s text box element when printed. If unset, then `unstackedTextBoxStyle` is used.
      Parameters:
        `unstackedPrintTextBoxStyle` - New unstackedPrintTextBoxStyle value. Default value is null
      Returns:
        `SpinnerItem` instance, for chaining setter calls
      See Also:
        `FormItemBaseStyle`, `Appearance overview and related methods`

    - #### getUnstackedPrintTextBoxStyle

          public java.lang.String getUnstackedPrintTextBoxStyle()

      In `unstacked mode`, the base CSS class name for the `SpinnerItem`'s text box element when printed. If unset, then `unstackedTextBoxStyle` is used.
      Returns:
        Current unstackedPrintTextBoxStyle value. Default value is null
      See Also:
        `FormItemBaseStyle`, `Appearance overview and related methods`

    - #### setUnstackedReadOnlyTextBoxStyle

          public SpinnerItem setUnstackedReadOnlyTextBoxStyle(java.lang.String unstackedReadOnlyTextBoxStyle)

      Parameters:
        `unstackedReadOnlyTextBoxStyle` - New unstackedReadOnlyTextBoxStyle value. Default value is null
      Returns:
        `SpinnerItem` instance, for chaining setter calls
      See Also:
        `FormItemBaseStyle`, `Appearance overview and related methods`

    - #### getUnstackedReadOnlyTextBoxStyle

          public java.lang.String getUnstackedReadOnlyTextBoxStyle()

      Returns:
        Current unstackedReadOnlyTextBoxStyle value. Default value is null
      See Also:
        `FormItemBaseStyle`, `Appearance overview and related methods`

    - #### setUnstackedTextBoxStyle

          public SpinnerItem setUnstackedTextBoxStyle(java.lang.String unstackedTextBoxStyle)

      In `unstacked mode`, the base CSS class name for the `SpinnerItem`'s text box element.

      NOTE: See the `CompoundFormItem_skinning` discussion for special skinning considerations.

      Parameters:
        `unstackedTextBoxStyle` - New unstackedTextBoxStyle value. Default value is "textItem"
      Returns:
        `SpinnerItem` instance, for chaining setter calls
      See Also:
        `FormItemBaseStyle`, `Appearance overview and related methods`

    - #### getUnstackedTextBoxStyle

          public java.lang.String getUnstackedTextBoxStyle()

      In `unstacked mode`, the base CSS class name for the `SpinnerItem`'s text box element.

      NOTE: See the `CompoundFormItem_skinning` discussion for special skinning considerations.

      Returns:
        Current unstackedTextBoxStyle value. Default value is "textItem"
      See Also:
        `FormItemBaseStyle`, `Appearance overview and related methods`

    - #### setWriteStackedIcons

          public SpinnerItem setWriteStackedIcons(java.lang.Boolean writeStackedIcons)

      When set to `true`, the increase and decrease icons are stacked on top of each other, also called stacked mode. When `false`, the increase and decrease icons are placed on the same line as the `SpinnerItem`'s text box, also called unstacked mode. When `null`, a default setting depending on `isTouch` is used (for touch browsers, the default is `false`/unstacked mode).

      In stacked mode, `increaseIcon` and `decreaseIcon` control the appearance of the stacked icons.

      In unstacked mode, `unstackedIncreaseIcon` and `unstackedDecreaseIcon` control the appearance of the unstacked icons.

      Parameters:
        `writeStackedIcons` - New writeStackedIcons value. Default value is null
      Returns:
        `SpinnerItem` instance, for chaining setter calls
      See Also:
        `Appearance overview and related methods`

    - #### getWriteStackedIcons

          public java.lang.Boolean getWriteStackedIcons()

      When set to `true`, the increase and decrease icons are stacked on top of each other, also called stacked mode. When `false`, the increase and decrease icons are placed on the same line as the `SpinnerItem`'s text box, also called unstacked mode. When `null`, a default setting depending on `isTouch` is used (for touch browsers, the default is `false`/unstacked mode).

      In stacked mode, `increaseIcon` and `decreaseIcon` control the appearance of the stacked icons.

      In unstacked mode, `unstackedIncreaseIcon` and `unstackedDecreaseIcon` control the appearance of the unstacked icons.

      Returns:
        Current writeStackedIcons value. Default value is null
      See Also:
        `Appearance overview and related methods`

    - #### setDefaultProperties

          public static void setDefaultProperties(SpinnerItem spinnerItemProperties)

      Class level method to set the default properties of this class. If set, then all existing and subsequently created instances of this class will automatically have default properties corresponding to the properties of the class instance passed to this function. This is a powerful feature that eliminates the need for users to create a separate hierarchy of subclasses that only alter the default properties of this class. Can also be used for skinning / styling purposes.

      Note: This method is intended for setting default attributes only and will affect all instances of the underlying class (including those automatically generated in JavaScript). This method should not be used to apply standard EventHandlers or override methods for a class - use a custom subclass instead. Calling this method after instances have been created can result in undefined behavior, since it bypasses any setters and a class instance may have already examined a particular property and not be expecting any changes through this route.

      Parameters:
        `spinnerItemProperties` - properties that should be used as new defaults when instances of this class are created
      See Also:
        `SGWTProperties`

    - #### setMax

          public final SpinnerItem setMax(java.lang.Integer max)

    - #### setMin

          public final SpinnerItem setMin(java.lang.Integer min)

    - #### setStep

          public final SpinnerItem setStep(java.lang.Integer step)

    - #### setStep

          public final SpinnerItem setStep(java.lang.Double step)

    - #### setMin

          public final SpinnerItem setMin(double min)

    - #### setMax

          public final SpinnerItem setMax(double max)

    - #### setNextValueHandler

          public void setNextValueHandler(NextValueHandler handler)

      When `min` and `max` are both null or unspecified, the nextValueHandler is used to get the next higher value from the currentValue. The default implementation returns (currentValue + step).

      To indicate that the given currentValue is the maximum value, return currentValue again.

      Implementations should expect to be passed any value for currentValue. Also, if `step` is non-negative, the nextValueHandler must induce a monotonically increasing (non-decreasing) function; otherwise, the nextValueHandler must induce a monotonically decreasing function.

    - #### setPreviousValueHandler

          public void setPreviousValueHandler(PreviousValueHandler handler)

      When `min` and `max` are both null or unspecified, the previousValueHandler is used to get the previous lower value from the currentValue. The default implementation returns (currentValue + step) because the step parameter is based on the opposite of `this.step`.

      To indicate that the given currentValue is the minimum value, return currentValue again.

      Implementations should expect to be passed any value for currentValue. Also, if `step` is non-negative, the previousValueHandler must induce a monotonically decreasing (non-increasing) function; otherwise, the previousValueHandler must induce a monotonically increasing function.